## libyang 0.16.105

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)
project(libyang C)

include(GNUInstallDirs)
include(CheckSymbolExists)

set(LIBYANG_DESCRIPTION "libyang is YANG data modelling language parser and toolkit written (and providing API) in C.")

# Correct RPATH usage on OS X
set(CMAKE_MACOSX_RPATH TRUE)

# set version
set(LIBYANG_MAJOR_VERSION 0)
set(LIBYANG_MINOR_VERSION 16)
set(LIBYANG_MICRO_VERSION 105)
set(LIBYANG_VERSION ${LIBYANG_MAJOR_VERSION}.${LIBYANG_MINOR_VERSION}.${LIBYANG_MICRO_VERSION})
set(LIBYANG_SOVERSION ${LIBYANG_MAJOR_VERSION}.${LIBYANG_MINOR_VERSION})

# set default build type if not specified by user
if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE debug)
endif()

set(CMAKE_C_STANDARD 11)
set(CMAKE_C_FLAGS         "${CMAKE_C_FLAGS} -Wall -Wextra")
set(CMAKE_C_FLAGS_RELEASE "-O2 -DNDEBUG")
set(CMAKE_C_FLAGS_PACKAGE "-g -O2 -DNDEBUG")
set(CMAKE_C_FLAGS_DEBUG   "-g -O0")

# options
if((CMAKE_BUILD_TYPE STREQUAL debug) OR (CMAKE_BUILD_TYPE STREQUAL Package))
    option(ENABLE_BUILD_TESTS "Build tests" ON)
    option(ENABLE_VALGRIND_TESTS "Build tests with valgrind" ON)
else()
    option(ENABLE_BUILD_TESTS "Build tests" OFF)
    option(ENABLE_VALGRIND_TESTS "Build tests with valgrind" OFF)
endif()
option(ENABLE_CALLGRIND_TESTS "Build performance tests to be run with callgrind" OFF)

option(ENABLE_CACHE "Enable data caching for schemas and hash tables for data (time-efficient at the cost of increased space-complexity)" ON)
option(ENABLE_LATEST_REVISIONS "Enable reusing of latest revisions of schemas" ON)
option(ENABLE_LYD_PRIV "Add a private pointer also to struct lyd_node (data node structure), just like in struct lys_node, for arbitrary user data" OFF)
set(PLUGINS_DIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}/libyang" CACHE STRING "Directory with libyang plugins (extensions and user types)")

if(ENABLE_CACHE)
    set(LY_ENABLED_CACHE 1)
endif()
if(ENABLE_LATEST_REVISIONS)
    set(LY_ENABLED_LATEST_REVISIONS 1)
endif()
if(ENABLE_LYD_PRIV)
    set(LY_ENABLED_LYD_PRIV 1)
endif()

if(CMAKE_C_COMPILER_ID STREQUAL "GNU")
    set(COMPILER_UNUSED_ATTR "UNUSED_ ## x __attribute__((__unused__))")
    set(COMPILER_PACKED_ATTR "__attribute__((__packed__))")
elseif(CMAKE_C_COMPILER_ID STREQUAL "Clang")
    # require at least clang 3.0
    if (CMAKE_C_COMPILER_VERSION VERSION_LESS 3.0)
        message(FATAL_ERROR "Clang version must be at least 3.0!")
    endif()
    set(COMPILER_UNUSED_ATTR "UNUSED_ ## x __attribute__((__unused__))")
    set(COMPILER_PACKED_ATTR "__attribute__((__packed__))")
else()
    message(WARNING "You are using an unknown compiler, it must support C11 standard \"_Generic\" statement or the \"__builtin_types_compatible_p\" built-in function.")
    set(COMPILER_UNUSED_ATTR "UNUSED_ ## x")
    set(COMPILER_PACKED_ATTR "")
endif()

include_directories(${PROJECT_BINARY_DIR}/src ${PROJECT_SOURCE_DIR}/src)
configure_file(${PROJECT_SOURCE_DIR}/src/libyang.h.in ${PROJECT_BINARY_DIR}/src/libyang.h @ONLY)
configure_file(${PROJECT_SOURCE_DIR}/src/common.h.in ${PROJECT_BINARY_DIR}/src/common.h @ONLY)

set(EXTENSIONS_PLUGINS_DIR_MACRO "${PLUGINS_DIR}/extensions")
set(USER_TYPES_PLUGINS_DIR_MACRO "${PLUGINS_DIR}/user_types")

# include custom Modules
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/CMakeModules/")

# setup bindings
set(GEN_LANGUAGE_BINDINGS 0 CACHE BOOL "Enable language bindings generation.")
set(GEN_CPP_BINDINGS 1 CACHE BOOL "Enable C++ bindings.")
# Python bindings depend on C++ bindings because of SWIG
set(GEN_PYTHON_BINDINGS 1 CACHE BOOL "Enable Python bindings.")
set(GEN_PYTHON_VERSION "3" CACHE STRING "Python version")
set(GEN_JAVASCRIPT_BINDINGS 0 CACHE BOOL "Enable JavaScript bindings.")
set(GEN_JAVA_BINDINGS 0 CACHE BOOL "Enable Java bindings.")

find_package(FLEX)
find_package(BISON)
find_program(DEB_BUILDER NAMES debuild)
find_program(RPM_BUILDER NAMES rpmbuild)
find_program(SED_TOOL NAMES sed)

if(NOT BISON_FOUND)
    message(WARNING "Missing Bison.\nYou won't be able to generate source codes from changed flex/bison files.\nCompiling libyang should still works fine.")
elseif (NOT FLEX_FOUND)
    message(WARNING "Missing Flex.\nYou won't be able to generate source codes from changed flex/bison files.\nCompiling libyang should still works fine.")
else()
    if (BISON_VERSION VERSION_LESS 3)
        set(EMPTYDIR "")
    else ()
        set(EMPTYDIR "%empty")
    endif()
    configure_file(${PROJECT_SOURCE_DIR}/src/yang.y.in ${PROJECT_BINARY_DIR}/src/yang.y)
    add_custom_target(bison
        WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}/src
        COMMAND bison -l -o parser_yang_bis.c --defines=parser_yang_bis.h ${PROJECT_BINARY_DIR}/src/yang.y
        COMMAND flex -8 -L -o parser_yang_lex.c --header-file=parser_yang_lex.h yang.l
        COMMAND ${SED_TOOL} -i 's/int yychar\;/int yychar\;\\nchar *s = NULL, *tmp_s = NULL, *ext_name = NULL\;\\nstruct lys_module *trg = NULL\;\\nstruct lys_node *tpdf_parent = NULL, *data_node = NULL\;\\nstruct lys_ext_instance_complex *ext_instance = NULL\;\\nint is_ext_instance\;\\nvoid *actual = NULL\;\\nenum yytokentype backup_type, actual_type = MODULE_KEYWORD\;\\nint64_t cnt_val = 0\;\\nint is_value = 0\;\\nvoid *yang_type = NULL\;/' parser_yang_bis.c
    )
endif()

if (NOT DEFINED ENV{TRAVIS_BRANCH})
    execute_process(COMMAND "git" "rev-parse" "--abbrev-ref" "HEAD"
                    OUTPUT_VARIABLE GIT_BRANCH
                    OUTPUT_STRIP_TRAILING_WHITESPACE
                    ERROR_QUIET
                )
    if (NOT GIT_BRANCH)
        set(ENV{TRAVIS_BRANCH} "master")
    else()
        if (GIT_BRANCH MATCHES "master|devel")
            set(ENV{TRAVIS_BRANCH} ${GIT_BRANCH})
        else()
            set(ENV{TRAVIS_BRANCH} "master")
        endif()
    endif()
    set(GIT_BRANCH $ENV{TRAVIS_BRANCH})
endif()

if ($ENV{TRAVIS_BRANCH} STREQUAL "master")
    set(PACKAGE_NAME "libyang")
    set(PACKAGE_PART_NAME "")
    set(BRANCH "master")
    set(BUILD_TYPE "Package")
    set(CONFLICT_PACKAGE_NAME "libyang-experimental")
else ()
    set(PACKAGE_NAME "libyang-experimental")
    set(PACKAGE_PART_NAME "-experimental")
    set(BRANCH "devel")
    set(BUILD_TYPE "debug")
    set(CONFLICT_PACKAGE_NAME "libyang")
endif()
# change version in config files
configure_file(${PROJECT_SOURCE_DIR}/packages/libyang.spec.in ${PROJECT_BINARY_DIR}/build-packages/libyang.spec)
configure_file(${PROJECT_SOURCE_DIR}/packages/libyang.dsc.in ${PROJECT_BINARY_DIR}/build-packages/libyang.dsc)
configure_file(${PROJECT_SOURCE_DIR}/packages/debian.control.in ${PROJECT_BINARY_DIR}/build-packages/debian.control @ONLY)
configure_file(${PROJECT_SOURCE_DIR}/packages/debian.rules.in ${PROJECT_BINARY_DIR}/build-packages/debian.rules)

if (NOT DEB_BUILDER)
    message(WARNING "Missing tools (devscripts, debhelper package) for building deb package.\nYou won't be able to generate deb package from source code.\nCompiling libyang should still works fine.")
else ()
    # target for local build deb package
    add_custom_target(build-deb
                      WORKING_DIRECTORY ${PROJECT_BINARY_DIR}
                      COMMAND build-packages/local-deb.sh
    )
    configure_file(${PROJECT_SOURCE_DIR}/packages/local-deb.sh.in ${PROJECT_BINARY_DIR}/build-packages/local-deb.sh @ONLY)
endif()

if (NOT RPM_BUILDER)
    message(WARNING "Missing tools (rpm package) for building rpm package. \nYou won't be able to generate rpm package from source code.\nCompiling libyang should still works fine.")
else ()
    # target for local build rpm package
    string(REPLACE ${PROJECT_SOURCE_DIR} "." EXCLUDE_BUILD_DIR ${PROJECT_BINARY_DIR})
    add_custom_target(build-rpm
                      WORKING_DIRECTORY ${PROJECT_BINARY_DIR}
                      COMMAND build-packages/local-rpm.sh
    )
    configure_file(${PROJECT_SOURCE_DIR}/packages/local-rpm.sh.in ${PROJECT_BINARY_DIR}/build-packages/local-rpm.sh @ONLY)
endif()

# by default build shared library
# static build requires static libpcre library
option(ENABLE_STATIC "Build static (.a) library" OFF)

# check the supported platform
if(NOT UNIX)
    message(FATAL_ERROR "Only *nix like systems are supported.")
endif()

set(libsrc
    src/common.c
    src/context.c
    src/log.c
    src/hash_table.c
    src/resolve.c
    src/validation.c
    src/xml.c
    src/parser.c
    src/parser_yin.c
    src/parser_xml.c
    src/parser_json.c
    src/parser_lyb.c
    src/parser_yang_bis.c
    src/parser_yang_lex.c
    src/parser_yang.c
    src/tree_schema.c
    src/tree_data.c
    src/plugins.c
    src/printer.c
    src/xpath.c
    src/printer_yang.c
    src/printer_yin.c
    src/printer_json_schema.c
    src/printer_xml.c
    src/printer_tree.c
    src/printer_info.c
    src/printer_json.c
    src/printer_lyb.c
    src/yang_types.c)

set(lintsrc
    tools/lint/main.c
    tools/lint/main_ni.c
    tools/lint/commands.c
    tools/lint/completion.c
    tools/lint/configuration.c
    linenoise/linenoise.c)

set(resrc
    tools/re/main.c)

set(yang2yinsrc
    tools/yang2yin/main.c)

set(headers
    src/tree_schema.h
    src/tree_data.h
    src/extensions.h
    src/user_types.h
    src/xml.h
    src/dict.h)

check_symbol_exists(vdprintf "stdio.h;stdarg.h" HAVE_VDPRINTF)
if(HAVE_VDPRINTF)
    add_definitions(-DHAVE_VDPRINTF)
endif(HAVE_VDPRINTF)

# create static libyang library
if(ENABLE_STATIC)
    add_definitions(-DSTATIC)
    set(CMAKE_EXE_LINKER_FLAGS -static)
    set(CMAKE_FIND_LIBRARY_SUFFIXES .a)
    set(CMAKE_EXE_LINK_DYNAMIC_C_FLAGS)       # remove -Wl,-Bdynamic
    set(CMAKE_EXE_LINK_DYNAMIC_CXX_FLAGS)
    add_library(yang STATIC ${libsrc})
else()
    set(CMAKE_POSITION_INDEPENDENT_CODE TRUE)
    add_library(yangobj OBJECT ${libsrc})
    add_library(yang SHARED $<TARGET_OBJECTS:yangobj>)

    #only for tests with visible internal symbols
    add_library(yangobj_tests OBJECT ${libsrc})

    #link dl
    target_link_libraries(yang ${CMAKE_DL_LIBS})

    set_target_properties(yangobj PROPERTIES COMPILE_FLAGS "-fvisibility=hidden")
endif(ENABLE_STATIC)

set_target_properties(yang PROPERTIES VERSION ${LIBYANG_VERSION} SOVERSION ${LIBYANG_SOVERSION})

# link math
target_link_libraries(yang m)

# find pthreads
set(CMAKE_THREAD_PREFER_PTHREAD TRUE)
find_package(Threads REQUIRED)
if(ENABLE_STATIC)
    target_link_libraries(yang -Wl,--whole-archive ${CMAKE_THREAD_LIBS_INIT} -Wl,--no-whole-archive)
else()
    target_link_libraries(yang ${CMAKE_THREAD_LIBS_INIT})
endif(ENABLE_STATIC)

# find PCRE library
unset(PCRE_LIBRARY CACHE)
find_package(PCRE REQUIRED)
include_directories(${PCRE_INCLUDE_DIRS})
target_link_libraries(yang ${PCRE_LIBRARIES})

install(TARGETS yang DESTINATION ${CMAKE_INSTALL_LIBDIR})
install(FILES ${headers} ${PROJECT_BINARY_DIR}/src/libyang.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/libyang)

find_package(PkgConfig)
if(PKG_CONFIG_FOUND)
    # generate and install pkg-config file
    configure_file("libyang.pc.in" "libyang.pc" @ONLY)
    install(FILES "${CMAKE_CURRENT_BINARY_DIR}/libyang.pc" DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig")
    # check that pkg-config includes the used path
    execute_process(COMMAND ${PKG_CONFIG_EXECUTABLE} --variable pc_path pkg-config RESULT_VARIABLE RETURN OUTPUT_VARIABLE PC_PATH ERROR_QUIET)
    if(RETURN EQUAL 0)
	string(STRIP "${PC_PATH}" PC_PATH)
	set(PC_PATH "${PC_PATH}:$ENV{PKG_CONFIG_PATH}")
        string(REGEX MATCH "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}/pkgconfig" SUBSTR "${PC_PATH}")
        string(LENGTH "${SUBSTR}" SUBSTR_LEN)
        if(SUBSTR_LEN EQUAL 0)
            message(WARNING "pkg-config will not detect the new package after installation, adjust PKG_CONFIG_PATH using \"export PKG_CONFIG_PATH=\${PKG_CONFIG_PATH}:${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}/pkgconfig\".")
        endif()
    endif()
endif()

# generate doxygen documentation for libyang API
find_package(Doxygen)
if(DOXYGEN_FOUND)
    find_program(DOT_PATH dot PATH_SUFFIXES graphviz2.38/bin graphviz/bin)
    if(DOT_PATH)
        set(HAVE_DOT "YES")
    else()

=== swig/CMakeLists.txt ===
project(libyang-cpp)

set(CMAKE_CXX_FLAGS         "${CMAKE_CXX_FLAGS} -Wall -Wextra -std=c++11")
set(CMAKE_CXX_FLAGS_RELEASE "-O2 -DNDEBUG")
set(CMAKE_CXX_FLAGS_PACKAGE "-g -O2 -DNDEBUG")
set(CMAKE_CXX_FLAGS_DEBUG   "-g -O0")

# temporary bugfix
add_compile_options(-std=c++11)

# find SWIG package
if(GEN_LANGUAGE_BINDINGS)
    find_package(SWIG 3.0.12 REQUIRED)
    if(NOT SWIG_FOUND)
        message(WARNING "SWIG library not found")
    else()
        include(${SWIG_USE_FILE})
    endif()
endif()

# find Python package
if(GEN_PYTHON_BINDINGS AND SWIG_FOUND)
    message(STATUS "Python version ${GEN_PYTHON_VERSION} was selected")
    unset(PYTHON_LIBRARY CACHE)
    unset(PYTHON_EXECUTABLE CACHE)
    unset(PYTHON_INCLUDE_DIR CACHE)
    unset(PYTHON_LIBRARY_DEBUG CACHE)
    if(${GEN_PYTHON_VERSION} STREQUAL "2")
        find_package(PythonLibs 2 REQUIRED)
        find_package(PythonInterp 2 REQUIRED)
        if(NOT PYTHONLIBS_FOUND)
            message(WARNING "Did not found Python version 2.x")
            message(STATUS "Sysrepo supports Python 2.x and Python 3.x")
        endif()
    elseif(${GEN_PYTHON_VERSION} STREQUAL "3")
        find_package(PythonLibs 3 REQUIRED)
        find_package(PythonInterp 3 REQUIRED)
        if(NOT PYTHONLIBS_FOUND)
            message(WARNING "Did not found Python version 3.x")
            message(STATUS "Sysrepo supports Python 2.x and Python 3.x")
        endif()
    else()
        message(WARNING "Sysrepo supports Python 2.x and Python 3.x")
    endif()
endif()

set(LIBYANG_CPP_SOURCES
    ${CMAKE_SOURCE_DIR}/swig/cpp/src/Xml.cpp
    ${CMAKE_SOURCE_DIR}/swig/cpp/src/Libyang.cpp
    ${CMAKE_SOURCE_DIR}/swig/cpp/src/Tree_Data.cpp
    ${CMAKE_SOURCE_DIR}/swig/cpp/src/Tree_Schema.cpp
    ${CMAKE_SOURCE_DIR}/swig/cpp/src/Internal.cpp)

set(LIBYANG_HPP_SOURCES
    ${CMAKE_SOURCE_DIR}/swig/cpp/src/Xml.hpp
    ${CMAKE_SOURCE_DIR}/swig/cpp/src/Libyang.hpp
    ${CMAKE_SOURCE_DIR}/swig/cpp/src/Tree_Data.hpp
    ${CMAKE_SOURCE_DIR}/swig/cpp/src/Tree_Schema.hpp
    ${CMAKE_SOURCE_DIR}/swig/cpp/src/Internal.hpp)

FUNCTION(PREPEND var prefix)
    SET(listVar "")
    FOREACH(f ${ARGN})
        LIST(APPEND listVar "${prefix}/${f}")
    ENDFOREACH(f)
    SET(${var} "${listVar}" PARENT_SCOPE)
ENDFUNCTION(PREPEND)

PREPEND(abs_libsrc ${CMAKE_SOURCE_DIR} ${libsrc})

if(ENABLE_STATIC)
    add_library(libyang-cpp STATIC ${LIBYANG_CPP_SOURCES})
else(ENABLE_STATIC)
    add_library(libyang-cpp SHARED ${LIBYANG_CPP_SOURCES})
endif(ENABLE_STATIC)
SET_TARGET_PROPERTIES(libyang-cpp PROPERTIES
    VERSION ${LIBYANG_VERSION} SOVERSION ${LIBYANG_SOVERSION} PREFIX "")

# include custom Modules
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/CMakeModules/")

include_directories(${CMAKE_SOURCE_DIR})
include_directories("${CMAKE_CURRENT_SOURCE_DIR}/cpp/src")
target_link_libraries(libyang-cpp yang)

if(PKG_CONFIG_FOUND)
    configure_file("${CMAKE_CURRENT_SOURCE_DIR}/libyang-cpp.pc.in" "${CMAKE_CURRENT_BINARY_DIR}/libyang-cpp.pc" @ONLY)
    install(FILES "${CMAKE_CURRENT_BINARY_DIR}/libyang-cpp.pc" DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig")
endif()

# install binary
install(TARGETS libyang-cpp DESTINATION ${CMAKE_INSTALL_LIBDIR})
install(FILES ${LIBYANG_HPP_SOURCES} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/libyang)

if (GEN_CPP_BINDINGS)
    add_subdirectory(cpp/examples)
    if (ENABLE_BUILD_TESTS)
        add_subdirectory(cpp/tests)
    endif()
endif()

if(ENABLE_STATIC AND PYTHONLIBS_FOUND AND PYTHONINTERP_FOUND AND (${GEN_PYTHON_VERSION} STREQUAL "2" OR ${GEN_PYTHON_VERSION} STREQUAL "3"))
    message(WARNING "Can't create a static Python module")
elseif(PYTHONLIBS_FOUND AND PYTHONINTERP_FOUND AND (${GEN_PYTHON_VERSION} STREQUAL "2" OR ${GEN_PYTHON_VERSION} STREQUAL "3"))
    add_subdirectory(python)
endif()

if(NOT ENABLE_STATIC AND GEN_JAVASCRIPT_BINDINGS)
    message(WARNING "Can't create Javascript bindings with a shared library, please use -DENABLE_STATIC")
elseif(ENABLE_STATIC AND GEN_JAVASCRIPT_BINDINGS)
    add_subdirectory(javascript)
endif()

if(ENABLE_STATIC AND GEN_JAVA_BINDINGS)
    message(WARNING "Can't create a static Java module")
elseif(NOT ENABLE_STATIC AND GEN_JAVA_BINDINGS)
    add_subdirectory(java)
endif()

=== src/user_types/CMakeLists.txt ===
macro(USER_TYPE_PLUGIN PLUGIN_NAME SRCS)
    add_library(${PLUGIN_NAME} SHARED ${SRCS})
    set_target_properties(${PLUGIN_NAME} PROPERTIES PREFIX "")
    target_link_libraries(${PLUGIN_NAME} yang)
    install(TARGETS ${PLUGIN_NAME} DESTINATION ${USER_TYPES_PLUGINS_DIR_MACRO})
endmacro(USER_TYPE_PLUGIN)

foreach(USER_TYPE ${USER_TYPE_LIST})
    USER_TYPE_PLUGIN(${USER_TYPE} "${USER_TYPE}.c")
endforeach()

=== swig/java/CMakeLists.txt ===
set(JAVA_SWIG_BINDING libyangJava)
find_package(Java REQUIRED)
find_package(JNI REQUIRED)

include_directories(${JNI_INCLUDE_DIRS})
message(STATUS "JNI_INCLUDE_DIRS: ${JNI_INCLUDE_DIRS}")
include_directories(${CMAKE_CURRENT_SOURCE_DIR})

set(CMAKE_SWIG_FLAGS "-c++")
set(CMAKE_SWIG_FLAGS "-I${PROJECT_SOURCE_DIR}")
set(CMAKE_SWIG_OUTDIR ${CMAKE_CURRENT_BINARY_DIR})

file(MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/org/cesnet")

set_source_files_properties(${JAVA_SWIG_BINDING}.i PROPERTIES CPLUSPLUS ON PREFIX "" SWIG_FLAGS "-package;org.cesnet")

if(${CMAKE_VERSION} VERSION_LESS "3.8.0")
    swig_add_module(${JAVA_SWIG_BINDING} java ${JAVA_SWIG_BINDING}.i)
else()
    swig_add_library(${JAVA_SWIG_BINDING} LANGUAGE java SOURCES ${JAVA_SWIG_BINDING}.i)
endif()

set_target_properties(${SWIG_MODULE_${JAVA_SWIG_BINDING}_REAL_NAME} PROPERTIES PREFIX "")
swig_link_libraries(${JAVA_SWIG_BINDING} ${JNI_LIBRARIES} libyang-cpp)

add_custom_command(TARGET ${JAVA_SWIG_BINDING} POST_BUILD COMMAND "${Java_JAVAC_EXECUTABLE}" *.java -d . COMMAND "${Java_JAR_EXECUTABLE}" -cvf libyang.jar org)
set(NATIVE_JAR "${CMAKE_CURRENT_BINARY_DIR}/libyang.jar")

# install so file
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/${JAVA_SWIG_BINDING}.so" DESTINATION "${CMAKE_INSTALL_LIBDIR}")

file(COPY "examples" DESTINATION "${CMAKE_CURRENT_BINARY_DIR}")
add_custom_command(TARGET ${JAVA_SWIG_BINDING} POST_BUILD
        COMMAND ${Java_JAVAC_EXECUTABLE} -cp .:${NATIVE_JAR} ${CMAKE_SWIG_OUTDIR}/examples/Context.java
        COMMAND ${Java_JAVAC_EXECUTABLE} -cp .:${NATIVE_JAR} ${CMAKE_SWIG_OUTDIR}/examples/ProcessTree.java
        COMMAND ${Java_JAVAC_EXECUTABLE} -cp .:${NATIVE_JAR} ${CMAKE_SWIG_OUTDIR}/examples/Xpath.java
        WORKING_DIRECTORY ${CMAKE_BINARY_DIR})

if (ENABLE_BUILD_TESTS)

    file(COPY "tests" DESTINATION "${CMAKE_CURRENT_BINARY_DIR}")
    set(JAVA_TEST_DIR ${CMAKE_CURRENT_BINARY_DIR}/tests)
    set(JUNIT_JAR ${JAVA_TEST_DIR}/junit-4.12.jar:${JAVA_TEST_DIR}/hamcrest-core-1.3.jar)
    set(JAVA_TEST_SRC
            LibyangTest
            TreeDataTest
            TreeSchemaTest)
    configure_file("${JAVA_TEST_DIR}/Constants.java.in" "${JAVA_TEST_DIR}/Constants.java" ESCAPE_QUOTES @ONLY)

    foreach(JTEST ${JAVA_TEST_SRC})
        add_custom_command(TARGET ${JAVA_SWIG_BINDING} POST_BUILD
                COMMAND ${Java_JAVAC_EXECUTABLE} -cp ${NATIVE_JAR}:${JUNIT_JAR}:${JAVA_TEST_DIR} ${JAVA_TEST_DIR}/${JTEST}.java
                WORKING_DIRECTORY ${CMAKE_BINARY_DIR})
     endforeach()

    add_subdirectory(tests)
endif()

=== swig/javascript/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)

find_package(Nodejs REQUIRED)
find_package(SWIG 3.0.12 REQUIRED)

add_compile_options(-std=gnu++11)

STRING(TOLOWER ${CMAKE_BUILD_TYPE} lower_type)
if(${lower_type} STREQUAL "release")
    set(JAVASCRIPT_BUILD_TYPE yang)
else()
    set(JAVASCRIPT_BUILD_TYPE yang-dev)
endif()

set(SWIG_DEST "${CMAKE_CURRENT_BINARY_DIR}")
file(MAKE_DIRECTORY ${SWIG_DEST})

set(V8_VERSION_HEX 0x0${V8_VERSION_MAJOR}${V8_VERSION_MINOR}${V8_VERSION_PATCH})
string(LENGTH "${V8_VERSION_HEX}" V8_VERSION_HEX_length)
while(V8_VERSION_HEX_length LESS 8)
    set(V8_VERSION_HEX "${V8_VERSION_HEX}0")
    string(LENGTH "${V8_VERSION_HEX}" V8_VERSION_HEX_length)
endwhile()

execute_process(COMMAND swig -c++ -javascript -node -DV8_VERSION=${V8_VERSION_HEX} -outcurrentdir -I${CMAKE_BINARY_DIR}/src -I${CMAKE_SOURCE_DIR}/src -I${CMAKE_SOURCE_DIR}/swig/cpp/src ${CMAKE_SOURCE_DIR}/swig/javascript/yang.i WORKING_DIRECTORY ${SWIG_DEST} RESULT_VARIABLE RET OUTPUT_VARIABLE OUT ERROR_VARIABLE ERROR)
if(NOT RET)
    function(PREPEND var prefix)
        set(listVar "")
        foreach(f ${ARGN})
            list(APPEND listVar "${prefix}/${f}")
        endforeach(f)
        set(${var} "${listVar}" PARENT_SCOPE)
    endfunction(PREPEND)

    macro(LIBYANG_CREATE_BINDING_GYP generated_file)
        set(libyang_LIB_SRCS_GYP "")
        PREPEND(libyang_NPM_SRCS "" ${libsrc})

        string(LENGTH "${CMAKE_SOURCE_DIR}/swig/cpp/" cpp_length)
        foreach(full_srcfile ${LIBYANG_CPP_SOURCES})
            string(SUBSTRING ${full_srcfile} ${cpp_length} -1 srcfile)
            set(libyang_LIB_SRCS_GYP "${libyang_LIB_SRCS_GYP}\n            '${srcfile}',")
        endforeach(full_srcfile)

        foreach(plugin ${USER_TYPE_LIST})
            set(libyang_LIB_SRCS_GYP "${libyang_LIB_SRCS_GYP}\n            'src/user_types/${plugin}.c',")
        endforeach(plugin)

        foreach(plugin ${EXTENSIONS_LIST})
            set(libyang_LIB_SRCS_GYP "${libyang_LIB_SRCS_GYP}\n            'src/extensions/${plugin}.c',")
        endforeach(plugin)

        foreach(srcfile ${libsrc})
            set(libyang_LIB_SRCS_GYP "${libyang_LIB_SRCS_GYP}\n            '${srcfile}',")
        endforeach(srcfile)

        configure_file(${CMAKE_SOURCE_DIR}/swig/javascript/${generated_file}.in ${SWIG_DEST}/${generated_file} @ONLY)
    endmacro(LIBYANG_CREATE_BINDING_GYP)
    LIBYANG_CREATE_BINDING_GYP(binding.gyp)

    file(COPY "${CMAKE_SOURCE_DIR}/src" DESTINATION ${SWIG_DEST})
    file(COPY "${CMAKE_SOURCE_DIR}/swig/cpp/src" DESTINATION ${SWIG_DEST})
    file(COPY "${CMAKE_BINARY_DIR}/src" DESTINATION "${SWIG_DEST}")
    file(COPY "${SWIG_DEST}/yang_wrap.cxx" DESTINATION "${SWIG_DEST}/src")
    file(COPY "${CMAKE_SOURCE_DIR}/models" DESTINATION ${SWIG_DEST})
    file(REMOVE "${SWIG_DEST}/yang_wrap.cxx")
    file(COPY "${CMAKE_SOURCE_DIR}/swig/javascript/README.md" DESTINATION "${SWIG_DEST}")
    file(COPY "${CMAKE_SOURCE_DIR}/swig/javascript/files" DESTINATION "${SWIG_DEST}")
    file(COPY "${CMAKE_SOURCE_DIR}/swig/javascript/test.js" DESTINATION "${SWIG_DEST}")
    configure_file("${CMAKE_SOURCE_DIR}/swig/javascript/index.js.in" "${SWIG_DEST}/index.js" ESCAPE_QUOTES @ONLY)
    configure_file("${CMAKE_SOURCE_DIR}/swig/javascript/package.json.in" "${SWIG_DEST}/package.json" ESCAPE_QUOTES @ONLY)
else()
    message(${ERROR})
endif()

# remove javascript directory with "make clean" command.
set_property(DIRECTORY ${EXECUTABLE_OUTPUT_PATH} PROPERTY ADDITIONAL_MAKE_CLEAN_FILES "${SWIG_DEST}")

=== tests/perf/Makefile ===
ITEMS=5000
CFLAGS=-Wall -O0

compilation: validation validation_xml addloop

all: addloop validation validation_xml sizes test

addloop: addloop.c
	$(CC) $(CFLAGS) -lyang $< -o $@

validation: validation.c
	$(CC) $(CFLAGS) -lyang $< -o $@

validation_xml: validation_xml.c
	$(CC) $(CFLAGS) -lxml2 -lxslt $< -o $@

sizes: sizes.c ../../src/tree_schema.h ../../src/tree_data.h
	$(CC) $(CFLAGS) $< -o $@

test: addloop validation validation_xml
	@rm -rf data.xml data_xml.xml addloop_result.xml; \
	echo "Adding 5000 list items one by one (libyang)"; \
	TIME=" time  : %Es\n memory: %MKb" time ./addloop perftest.yin | grep real | sed 's/* //'; \
	echo;
	@for i in $(shell seq 1 ${ITEMS}); do \
		echo "<ptest1 xmlns=\"urn:libyang:performance:test\"><index>$$i</index><p1>$$i</p1></ptest1>" >> data.xml; \
	done;
	@echo "<config xmlns=\"urn:ietf:params:xml:ns:netconf:base:1.0\">" > data_xml.xml; \
	cat data.xml >> data_xml.xml; \
	echo "</config>" >> data_xml.xml; \
	echo "Loading and validating data with $(ITEMS) items..."; \
	echo "libyang"; \
	TIME=" time  : %Es\n memory: %MKb" time ./validation perftest.yin data.xml | grep real | sed 's/* //'; \
	echo; \
	echo "libxml2"; \
	TIME=" time  : %Es\n memory: %MKb" time ./validation_xml perftest.yin data_xml.xml perftest-config.rng perftest-schematron.xsl; \

clean:
	rm -rf sizes validation validation_xml addloop data.xml data_xml.xml addloop_result.xml

=== swig/java/tests/CMakeLists.txt ===
foreach(JTEST ${JAVA_TEST_SRC})

    add_test(NAME java_${JTEST}
            COMMAND ${Java_JAVA_EXECUTABLE}  -Djava.library.path=${CMAKE_SWIG_OUTDIR} -cp ${JAVA_TEST_DIR}:${NATIVE_JAR}:${JUNIT_JAR} ${JTEST}
            WORKING_DIRECTORY ${JAVA_TEST_DIR})

endforeach()

=== debian/changelog ===
libyang (0.16.105-3build1) focal; urgency=medium

  * No-change rebuild to drop python3.7.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 18 Feb 2020 10:20:45 +0100

libyang (0.16.105-3) unstable; urgency=medium

  * work around parallel build issues with python bindings (build only change)

 -- David Lamparter <equinox-debian@diac24.net>  Mon, 20 Jan 2020 17:20:21 +0100

libyang (0.16.105-2) unstable; urgency=medium

  * fix CVE-2019-19333 & CVE-2019-19334 (Closes: #946217)
  * fix cache corruption crash (upstream bug 752)
  * fix some gcc & swig version dependent build failures (Closes: #925764)

 -- David Lamparter <equinox-debian@diac24.net>  Sun, 22 Dec 2019 14:27:01 +0100

libyang (0.16.105-1) unstable; urgency=medium

  * upstream 0.16.105 (0.16-r3) release

 -- David Lamparter <equinox-debian@diac24.net>  Wed, 23 Jan 2019 01:32:43 +0100

libyang (0.16.52-2) unstable; urgency=medium

  * use correct DEB_HOST_GNU_TYPE to fix i386 build
  * mark non-libyang C++ symbols as optional (fixes build on several arch)
  * pull in 2 upstraem fixes to get build working on big-endian

 -- David Lamparter <equinox-debian@diac24.net>  Thu, 06 Dec 2018 13:33:08 +0100

libyang (0.16.52-1) unstable; urgency=medium

  * Initial release.
  * Closes: #913219

 -- David Lamparter <equinox-debian@diac24.net>  Sun, 18 Nov 2018 19:30:04 +0100

=== debian/control ===
Source: libyang
Section: libs
Homepage: https://netopeer.liberouter.org/
Maintainer: David Lamparter <equinox-debian@diac24.net>
Uploaders: CESNET <rkrejci@cesnet.cz>
Priority: optional
Standards-Version: 4.2.1
Build-Depends:
 bison,
 cmake,
 debhelper (>= 11~),
 dh-python,
 libcmocka-dev <!nocheck>,
 libpcre3-dev,
 swig (>= 3.0.12),
 python3-all-dev,
 python3-all-dbg,
 pkg-config
Vcs-Browser: https://github.com/CESNET/libyang/tree/debian
Vcs-Git: https://github.com/CESNET/libyang.git -b debian

Package: libyang0.16
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Architecture: any
Description: parser toolkit for IETF YANG data modeling - runtime
 Libyang implements functions to process schemas expressed in the
 YANG data modeling language defined by the IETF in RFCs 6020/7950.
 Schemas expressed in this language primarily describe configuration
 used by larger network equipment like routers and switches.
 .
 In addition to handling the schemas itself, the library also provides
 functions to process data described by the schemas.
 .
 The library is implemented in C and provides an API for other software
 to use in processing configurations.

Package: libyang-dev
Depends:
 ${misc:Depends},
 libpcre3-dev,
 libyang0.16 (= ${binary:Version})
Section: libdevel
Architecture: any
Description: parser toolkit for IETF YANG data modeling - development files
 Libyang implements functions to process schemas expressed in the
 YANG data modeling language defined by the IETF in RFCs 6020/7950.
 Schemas expressed in this language primarily describe configuration
 used by larger network equipment like routers and switches.
 .
 In addition to handling the schemas itself, the library also provides
 functions to process data described by the schemas.
 .
 This package contains the C headers, a pkgconfig file, and .so entry point
 for libyang.

Package: yang-tools
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 libyang0.16 (= ${binary:Version})
Section: devel
Architecture: any
Description: parser toolkit for IETF YANG data modeling - executable tools
 This package provides the "yanglint" and "yangre" tools which can be used
 during the creation of IETF YANG schemas.  The tools are not generally
 useful for normal operation where libyang primarily processes configuration
 data, not schemas.

Package: libyang-cpp0.16
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 libyang0.16 (= ${binary:Version})
Architecture: any
Description: parser toolkit for IETF YANG data modeling - C++ runtime
 Partially SWIG-generated bindings to use libyang with a C++ API.
 The functionality is the same as in libyang, the C++ code links wraps
 and uses libyang C code.

Package: libyang-cpp-dev
Depends:
 ${misc:Depends},
 libyang-cpp0.16 (= ${binary:Version}),
 libyang-dev (= ${binary:Version})
Section: libdevel
Architecture: any
Description: parser toolkit for IETF YANG data modeling - C++ development files
 Partially SWIG-generated bindings to use libyang with a C++ API.
 The functionality is the same as in libyang, the C++ code links wraps
 and uses libyang C code.
 .
 This is the accompanying development package, containing headers, a
 pkgconfig file, and .so entry point for the libyang C++ bindings.

Package: python3-yang
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 ${python3:Depends},
 libyang-cpp0.16 (= ${binary:Version})
Section: python
Architecture: any
Description: parser toolkit for IETF YANG data modeling - python3 support
 This package allows using libyang functionality to load IETF YANG models
 and data from Python3 code.
 .
 The bindings are partially generated by SWIG.

Package: python3-yang-dbg
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 ${python3:Depends},
 python3-yang (=${binary:Version})
Section: debug
Architecture: any
Description: parser toolkit for IETF YANG data modeling - python3 debug
 This package allows using libyang functionality to load IETF YANG models
 and data from Python3 code.
 .
 This package contains support for debug versions of Python.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/architecture.mk

%:
	dh $@ --with python3

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_BUILD_TYPE:String="Package" \
		-DENABLE_LYD_PRIV=ON \
		-DGEN_LANGUAGE_BINDINGS=ON \
		-DGEN_JAVA_BINDINGS=OFF \
		-DGEN_JAVASCRIPT_BINDINGS=OFF \
		-DGEN_PYTHON_VERSION=`/usr/bin/py3versions -s | sed \
			-e 's/python\(3\.[0-7]\)/\1;\1dm/g' \
			-e 's/python\([^ ]\+\)/\1;\1d/g' \
			-e 's/ /;/g'`

# building the SWIG generated Python bindings uses >= 1.5GB RAM per each
# g++ process, and this will be attempted in parallel.  Just build these bits
# in sequence to avoid OOM build failures.

override_dh_auto_build:
	dh_auto_build -- yang libyang-cpp
	set -e; /usr/bin/py3versions -s | sed \
			-e 's/python\(3\.[0-7]\)/\1 \1dm/g' \
			-e 's/python\([^ ]\+\)/\1 \1d/g' \
			-e 's/ /\n/g' | while read V; do \
		dh_auto_build --no-parallel -- _yang$${V}; \
	done
	dh_auto_build

override_dh_auto_install:
	dh_auto_install
	-rm -rf debian/tmp/usr/lib/python3
	set -e; /usr/bin/py3versions -s | sed -e 's/python\([^ ]\+\)/\1/g' -e 's/ /\n/g' | while read V; do \
		make -C obj-$(DEB_HOST_GNU_TYPE)/swig/python$${V} DESTDIR=`pwd`/debian/python3-yang     install; \
	done
	set -e; /usr/bin/py3versions -s | sed -e 's/python\(3\.[0-7]\)/\1dm/g' -e 's/python\([^ ]\+\)/\1d/g' -e 's/ /\n/g' | while read V; do \
		make -C obj-$(DEB_HOST_GNU_TYPE)/swig/python$${V} DESTDIR=`pwd`/debian/python3-yang-dbg install; \
	done
	-rm -rf debian/python3-yang/usr/include
	-rm -rf debian/python3-yang-dbg/usr/include

override_dh_strip:
	dh_strip -Npython3-yang-dbg -Npython3-yang
	dh_strip -ppython3-yang --dbg-package=python3-yang-dbg

override_dh_makeshlibs:
	dh_makeshlibs -Xextensions -Xuser_types

override_dh_auto_test:
ifeq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	make -C obj-$(DEB_HOST_GNU_TYPE) test ARGS=-V
endif

## libyang 0.16.105+really1.0

=== debian/changelog ===
libyang (0.16.105+really1.0-0+deb10u1) buster-security; urgency=high

  * Non-maintainer upload by the LTS team.
  * Backport Bullseye version of libyang to facilitate security update of frr.
  * Fix CVE-2019-20391, CVE-2019-20392, CVE-2019-20393, CVE-2019-20394,
    CVE-2019-20395, CVE-2019-20396, CVE-2019-20397, CVE-2019-20398.
    Multiple flaws were found in libyang, a parser toolkit for IETF YANG data
    modeling. Double frees, invalid memory access and Null pointer dereferences
    may cause a denial of service or potentially code execution.

 -- Markus Koschany <apo@debian.org>  Tue, 19 Sep 2023 17:53:50 +0200

libyang (0.16.105-1+deb10u1) buster; urgency=medium

  * Fix CVE-2019-19333 & CVE-2019-19334 (Closes: #946217)
  * Fix cache corruption crash (upstream bug 752)

 -- Ondřej Surý <ondrej@debian.org>  Tue, 12 May 2020 09:02:56 +0200

=== debian/control ===
--- 
+++ 
@@ -9,12 +9,8 @@
  bison,
  cmake,
  debhelper (>= 11~),
- dh-python,
  libcmocka-dev <!nocheck>,
  libpcre3-dev,
- swig (>= 3.0.12),
- python3-all-dev,
- python3-all-dbg,
  pkg-config
 Vcs-Browser: https://github.com/CESNET/libyang/tree/debian
 Vcs-Git: https://github.com/CESNET/libyang.git -b debian
@@ -94,30 +90,3 @@
  This is the accompanying development package, containing headers, a
  pkgconfig file, and .so entry point for the libyang C++ bindings.
 
-Package: python3-yang
-Depends:
- ${misc:Depends},
- ${shlibs:Depends},
- ${python3:Depends},
- libyang-cpp0.16 (= ${binary:Version})
-Section: python
-Architecture: any
-Description: parser toolkit for IETF YANG data modeling - python3 support
- This package allows using libyang functionality to load IETF YANG models
- and data from Python3 code.
- .
- The bindings are partially generated by SWIG.
-
-Package: python3-yang-dbg
-Depends:
- ${misc:Depends},
- ${shlibs:Depends},
- ${python3:Depends},
- python3-yang (=${binary:Version})
-Section: debug
-Architecture: any
-Description: parser toolkit for IETF YANG data modeling - python3 debug
- This package allows using libyang functionality to load IETF YANG models
- and data from Python3 code.
- .
- This package contains support for debug versions of Python.

## libyang 1.0.184

=== debian/changelog ===
libyang (1.0.184-2ubuntu1) groovy; urgency=medium

  * Drop Python autopkgtest since python3-yang is not built anymore

 -- Balint Reczey <rbalint@ubuntu.com>  Tue, 15 Sep 2020 18:59:51 +0200

libyang (1.0.184-2) unstable; urgency=medium

  * Move the C++ symbols file to be amd64 only (Closes: #969073)

 -- Ondřej Surý <ondrej@debian.org>  Fri, 04 Sep 2020 10:16:16 +0200

libyang (1.0.184-1) unstable; urgency=medium

  * Remove upstream patches merged upstream
  * Update changelog for 1.0.184-1~1.gbp418b5c release
  * Update symbols files for libyang_1.0.184

 -- Ondřej Surý <ondrej@debian.org>  Tue, 21 Jul 2020 16:36:41 +0200

libyang (1.0.176-3) unstable; urgency=medium

  * Add upstream patch for 'data tree BUGFIX hash canonical values for leaves'

 -- Ondřej Surý <ondrej@debian.org>  Sun, 19 Jul 2020 11:00:20 +0200

libyang (1.0.176-2) unstable; urgency=medium

  * Make the C++ symbols human readable
  * Mark symbols missing on Debian jessie as optional
  * Renamed yang-tools package to libyang-tools

 -- Ondřej Surý <ondrej@debian.org>  Wed, 15 Jul 2020 09:35:56 +0200

libyang (1.0.176-1) unstable; urgency=medium

  * New upstream release
  * Add SymbolsHelper-Confirmed header
  * Update symbols files for libyang 1.0.176

 -- Ondřej Surý <ondrej@debian.org>  Mon, 08 Jun 2020 11:21:04 +0200

libyang (1.0.167-1) experimental; urgency=medium

  [ David Lamparter ]
  * major version bump (0.16 -> 1.0)

  [ Ondřej Surý ]
  * Add d/gbp.conf
  * Add README.source on how to work with upstream repository
  * Rediff patches
  * Drop the python bindings
  * Use pkg-kde-tools to regenerate symbols
  * Lower the dh_compat level to 10
  * Add lintian-overrides for the plugins
  * Move the maintainer notes to README.source
  * Add myself to uploaders
  * Add extensions to the libyang1.symbols file

 -- Ondřej Surý <ondrej@debian.org>  Fri, 22 May 2020 10:54:51 +0200

=== debian/control ===
--- 
+++ 
@@ -1,24 +1,24 @@
 Source: libyang
 Section: libs
 Homepage: https://netopeer.liberouter.org/
-Maintainer: David Lamparter <equinox-debian@diac24.net>
-Uploaders: CESNET <rkrejci@cesnet.cz>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: David Lamparter <equinox-debian@diac24.net>
+Uploaders: CESNET <rkrejci@cesnet.cz>,
+           Ondřej Surý <ondrej@debian.org>
 Priority: optional
-Standards-Version: 4.2.1
-Build-Depends:
- bison,
- cmake,
- debhelper (>= 11~),
- libcmocka-dev <!nocheck>,
- libpcre3-dev,
- pkg-config
-Vcs-Browser: https://github.com/CESNET/libyang/tree/debian
-Vcs-Git: https://github.com/CESNET/libyang.git -b debian
+Standards-Version: 4.5.0
+Build-Depends: bison,
+               cmake,
+               debhelper (>= 9.20150101),
+               libcmocka-dev <!nocheck>,
+               libpcre3-dev,
+               pkg-config
+Vcs-Browser: https://github.com/CESNET/libyang/tree/debian/master
+Vcs-Git: https://github.com/CESNET/libyang.git -b debian/master
 
-Package: libyang0.16
-Depends:
- ${misc:Depends},
- ${shlibs:Depends}
+Package: libyang1
+Depends: ${misc:Depends},
+         ${shlibs:Depends}
 Architecture: any
 Description: parser toolkit for IETF YANG data modeling - runtime
  Libyang implements functions to process schemas expressed in the
@@ -33,10 +33,9 @@
  to use in processing configurations.
 
 Package: libyang-dev
-Depends:
- ${misc:Depends},
- libpcre3-dev,
- libyang0.16 (= ${binary:Version})
+Depends: libpcre3-dev,
+         libyang1 (= ${binary:Version}),
+         ${misc:Depends}
 Section: libdevel
 Architecture: any
 Description: parser toolkit for IETF YANG data modeling - development files
@@ -51,11 +50,12 @@
  This package contains the C headers, a pkgconfig file, and .so entry point
  for libyang.
 
-Package: yang-tools
-Depends:
- ${misc:Depends},
- ${shlibs:Depends},
- libyang0.16 (= ${binary:Version})
+Package: libyang-tools
+Depends: libyang1 (= ${binary:Version}),
+         ${misc:Depends},
+         ${shlibs:Depends}
+Breaks: yang-tools (<< ${source:Version})
+Replaces: yang-tools (<< ${source:Version})
 Section: devel
 Architecture: any
 Description: parser toolkit for IETF YANG data modeling - executable tools
@@ -64,11 +64,10 @@
  useful for normal operation where libyang primarily processes configuration
  data, not schemas.
 
-Package: libyang-cpp0.16
-Depends:
- ${misc:Depends},
- ${shlibs:Depends},
- libyang0.16 (= ${binary:Version})
+Package: libyang-cpp1
+Depends: libyang1 (= ${binary:Version}),
+         ${misc:Depends},
+         ${shlibs:Depends}
 Architecture: any
 Description: parser toolkit for IETF YANG data modeling - C++ runtime
  Partially SWIG-generated bindings to use libyang with a C++ API.
@@ -76,10 +75,9 @@
  and uses libyang C code.
 
 Package: libyang-cpp-dev
-Depends:
- ${misc:Depends},
- libyang-cpp0.16 (= ${binary:Version}),
- libyang-dev (= ${binary:Version})
+Depends: libyang-cpp1 (= ${binary:Version}),
+         libyang-dev (= ${binary:Version}),
+         ${misc:Depends}
 Section: libdevel
 Architecture: any
 Description: parser toolkit for IETF YANG data modeling - C++ development files
@@ -90,3 +88,11 @@
  This is the accompanying development package, containing headers, a
  pkgconfig file, and .so entry point for the libyang C++ bindings.
 
+Package: yang-tools
+Depends: libyang-tools (>= ${source:Version}),
+         ${misc:Depends}
+Section: oldlibs
+Architecture: all
+Description: parser toolkit for IETF YANG data modeling [dummy package]
+ This is empty dependency package to pull the executable tools.  It's
+ safe to remove.
